/*
 * Ejercicio2.java
 *
 * Creado el 16 de mayo de 2006, 10:17
 */


package metodosLineales.practica7;
import auxiliar.*;

/**
 * Para estudiar la convergencia de los mtodos iterativos de Jacobi y 
 * Gauss-Seidel para las matrices A1 y A2 dadas, tomaremos al azar cinco 
 * terminos independientes y resolveremos los respectivos sistemas, comparando
 * los resultados con los obtenidos con un mtodo directo (Gauss Total).
 *
 * @author Vctor Jimnez
 *
 * MTODOS NUMRICOS
 * LICENCIATURA DE MATEMTICAS
 * UNIVERSIDAD DE MURCIA
 */
public class Ejercicio2 {
    
    public static void main(String[] args) {
        double[][] A1 = {{1, 2, - 2}, {1, 1, 1}, {2, 2, 1}};
	double[][] A2 = {{2, - 1, 1}, {2, 2, 2}, { - 1, - 1, 2}};
        double[] b = new double[3];
        double[] xaprox = new double[3];
        
        System.out.println();
        System.out.println("Matriz A1:");
        Matrices.escribe(A1);        
        for (int k = 1; k <= 5; k++) {
            for (int i = 0; i < 3; i++) {
                b[i] = Math.random();
            }
            System.out.println();
            System.out.println("Trmino independiente b (eleccin " + k + "):");            
            Matrices.escribe(b);
            try {
                System.out.println();
                System.out.println("Resolucin de A1 x = b por Gauss Total:");
                Matrices.escribe(Matrices.gaussTotal(A1, b));             
            } catch(Matrices.ErrorMetodosLineales err) {                
            }
            try {
                System.out.println();
                System.out.println("Resolucin de A1 x = b por Jacobi:");
                xaprox = Matrices.iterJacobi(A1, b, 1E-7, 100);
                System.out.println("Solucin aproximada:");
                Matrices.escribe(xaprox);
            } catch(Matrices.ErrorMetodosLineales err) {                
            }
            try {
                System.out.println();
                System.out.println("Resolucin de A1 x = b por Gauss-Seidel:");
                xaprox = Matrices.iterGaussSeidel(A1, b, 1E-7, 100);
                System.out.println("Solucin aproximada:");
                Matrices.escribe(xaprox);                
            } catch(Matrices.ErrorMetodosLineales err) {                
            }
        }
        
        System.out.println();
        System.out.println("Matriz A2:");
        Matrices.escribe(A2);
        for (int k = 1; k <= 5; k++) {
            for (int i = 0; i < 3; i++) {
                b[i] = Math.random();
            }
            System.out.println();
            System.out.println("Trmino independiente b (eleccin " + k + "):");
            Matrices.escribe(b);
            try {
                System.out.println();
                System.out.println("Resolucin de A2 x = b por Gauss Total:");
                Matrices.escribe(Matrices.gaussTotal(A2, b));             
            } catch(Matrices.ErrorMetodosLineales err) {                
            }
            try {
                System.out.println();
                System.out.println("Resolucin de A2 x = b por Jacobi:");
                xaprox = Matrices.iterJacobi(A2, b, 1E-7, 100);
                System.out.println("Solucin aproximada:");
                Matrices.escribe(xaprox);
            } catch(Matrices.ErrorMetodosLineales err) {                
            }
            try {
                System.out.println();
                System.out.println("Resolucin de A2 x = b por Gauss-Seidel:");
                xaprox = Matrices.iterGaussSeidel(A2, b, 1E-7, 100);
                System.out.println("Solucin aproximada:");
                Matrices.escribe(xaprox);                
            } catch(Matrices.ErrorMetodosLineales err) {                
            }
        }
        
    }
    
}
